package imagemed.layout.validator;

import imagemed.util.LocalizedMessage;
import java.text.Format;

public class DefaultschReferrerValidator extends DBValidator {

	@Override
	protected void preValidate() {
		setMandatory( "0XNA", false );
	}


	private void checkFaxNo( String colid ) {
		String faxNo = getValue( colid );
		if ( faxNo != null && faxNo.length() > 0 && faxNo.length() < 6 ) {
			m_warnings.add( LocalizedMessage.getCompoundMessage( "DEFAULT_SCH_REFERRER_VALIDATOR_FIELD_LEAST_SIX_DIGITS", new Format[]{ null }, new Object[]{ getLabel( colid ) }, false ) );
		}
	}

	@Override
	public void validate() {
		setPrimaryWarning( new String[]{ "0XNA", "0XCP" } );

		// Office Fax Number, if present, should be >=6 digits
		checkFaxNo( "0XOF" );

		// Secondary Fax Number, if present, should be >=6 digits
		checkFaxNo( "0XF2" );
	}


}
