<%--
 ** Component: scheduler
 **
 ** Description:
 **   this jsp page is intended to be used by type-ahead macros
 **   
 **
 ** Parameters: 
 **
 **  @param cQueryMode		indicates whether we query based on DB ("TADB") or CFG file ("TACFG")
 **  @param cTable				name of the table to be queried (if not given, the table containing 
 **												the cField will be used)
 **	 @param cFile					name of the cfg file to be used (defaults to COLID.cfg)
 **	 @param cQueryLimit		limit of results (defaults to 10), 0 means no limit
 **  @param cField				COLID or fieldName of the queried field (obligatory if cFile is not missing)
 **  @param cPrefix 			value of cFilterField (if not given, all values are to be returned)
 **
 ** $Author$
 ** $Date$
 **
 *
 *  RCS File Name    : $RCSfile$
 *  RCS Revision     : $Revision$
 *  Locked by        : $Locker$
 *  Symbolic name    : $Name$
 *  State            : $State$
 --%><%@
	page import="imagemed.imsession.*, imagemed.imtables.*,	imagemed.tables.*, java.util.*,
	imagemed.layout.macro.input.TypeAheadInputMacro, imagemed.layout.datasource.DBLayoutDataSource"
%><%@
	page errorPage ="../main/exceptionHandler.jsp"
%><%-- Input Parameters --%><%!

private boolean isValSet(String val) {
	return val != null && val.length() > 0;
}

%><%

	IMSession is = new IMSession(request, response, out); 
	is.setNonCacheable();
	response.setContentType("text/plain");
	if (!is.regOK()) {
		out.println("FAILED (NoReg)");
		return;
	}
	String parPrefix = is.imRequest.getVal("cPrefix", "");
	boolean caseInsensitive = "true".equals(is.imRequest.getVal("cCaseInsensitive"));
	String parQueryMode = is.imRequest.getVal("cQueryMode");
	String parTable = is.imRequest.getVal("cTable");
	String parField = DBLayoutDataSource.field2COLID(is.imRequest.getVal("cField"));
	if (!isValSet(parTable)) {
		parTable = DBLayoutDataSource.field2Table(is.imRequest.getVal("cField"));
	}
	String parFile = is.imRequest.getVal("cFile");
	if (!isValSet(parQueryMode)) {
		if (isValSet(parTable) == isValSet(parFile)) {
			out.println("FAILED (No cQueryMode)");
			return;
		}
		parQueryMode = isValSet(parTable)?TypeAheadInputMacro.TAQUERYDB:TypeAheadInputMacro.TAQUERYCFG;
	}

	if (TypeAheadInputMacro.TAQUERYDB.equals(parQueryMode)) {
		// determining missing parameters for DB mode
		if (!isValSet(parField)) {
			out.println("FAILED (No cField)");
			return;
		}
		Set<String> tables = IMBaseFieldManager.staticGetTableNames(parField);
		if (!isValSet(parTable) && tables.size() != 1) {
			out.println("FAILED (No cTable)");
			return;
		}
		if (isValSet(parTable)) {
			if (!tables.contains(parTable)) {
				out.println("FAILED (Invalid cTable)");
				return;
			}
		}
		else {
			parTable = tables.iterator().next();
		}
	}
	else if (TypeAheadInputMacro.TAQUERYCFG.equals(parQueryMode)) {
		// determining missing parameters for CFG mode
		if (!isValSet(parField) && !isValSet(parFile)) {
			out.println("FAILED (Neither cField nor cFile)");
			return;
		}
		if (!isValSet(parFile)) {
			parFile = parField+".lst";
		}
		if (!isValSet(parField)) {
			parField = "XXXX"; // doesn't really matter here
		}
	}
	else {
		out.println("FAILED (Invalid cQueryMode)");
	}
	
	int parQueryLimit = 10;
	try {
		parQueryLimit = Integer.parseInt(is.imRequest.getVal("cQueryLimit"));
		if (parQueryLimit < 1) {
			// no limit
			parQueryLimit = Integer.MAX_VALUE;
		}
	}
	catch (Throwable nocare) {}

	Result result = null;
	if (TypeAheadInputMacro.TAQUERYCFG.equals(parQueryMode)) {
		// prefix based query for type-ahead macro(s)
		result = new ConfigFileResult(parField, parFile, parPrefix, "true".equals(is.imRequest.getVal("cDontSort")), caseInsensitive);
	}
	else {
		TableParams tp = new TableParams();
		tp.setPageSize(parQueryLimit);
		tp.setDefaultFields(new String[]{parField});
		if (isValSet(parPrefix)) {
			Properties filterProps = new Properties();
			filterProps.setProperty(parField, parPrefix+"*");
			tp.setDefaultFilters(filterProps);
			tp.setDefaultSort(new String[]{parField});
		}
		else { // if no filtering, the caseInsensitive flag just does wrong
			caseInsensitive = false;
		}
		result = new FieldValuesResult(tp, parTable, parField, caseInsensitive);
	}
	if (result.next()) {
		if (result.countAll() > parQueryLimit) {
			out.print("LIMITED");
		}
		else {
			out.print("OK");
		}
		for (int i=0; i<parQueryLimit; i++) {
			out.print("\n"+result.getValue(parField));
			if (!result.next()) {
				break;
			}
		}
	}
	else {
		out.println("FAILED (No record)");
	}
	if (true) {
		return;
	}
%>